#!/bin/bash
shopt -s globstar nullglob dotglob

query=$(cat <<EOF
PREFIX m: <http://www.w3.org/1998/Math/MathML#>
PREFIX cl: <http://purl.obolibrary.org/obo/CL>
PREFIX co: <http://purl.org/co/>
PREFIX ex: <http://www.example.org#>
PREFIX go: <http://purl.obolibrary.org/obo/GO>
PREFIX qb: <http://purl.org/linked-data/cube#>
PREFIX ro: <http://purl.obolibrary.org/obo/RO>
PREFIX uo: <http://purl.obolibrary.org/obo/UO>
PREFIX dct: <http://purl.org/dc/terms/>
PREFIX hdf: <http://purl.allotrope.org/ontologies/hdf5/1.8#>
PREFIX ldp: <http://purl.org/ldp/>
PREFIX map: <http://purl.allotrope.org/ontologies/mapping/instances#>
PREFIX ops: <http://www.openphacts.org/units/>
PREFIX ore: <http://www.openarchives.org/ore/terms/>
PREFIX org: <http://www.w3.org/ns/org#>
PREFIX owl: <http://www.w3.org/2002/07/owl#>
PREFIX pav: <http://purl.org/pav/>
PREFIX rdf: <http://www.w3.org/1999/02/22-rdf-syntax-ns#>
PREFIX xml: <http://www.w3.org/xml/1998/namespace>
PREFIX xsd: <http://www.w3.org/2001/XMLSchema#>
PREFIX af-c: <http://purl.allotrope.org/ontologies/common#>
PREFIX af-e: <http://purl.allotrope.org/ontologies/equipment#>
PREFIX af-m: <http://purl.allotrope.org/ontologies/material#>
PREFIX af-p: <http://purl.allotrope.org/ontologies/process#>
PREFIX af-q: <http://purl.allotrope.org/ontologies/quality#>
PREFIX af-r: <http://purl.allotrope.org/ontologies/result#>
PREFIX af-x: <http://purl.allotrope.org/ontologies/property#>
PREFIX caro: <http://purl.obolibrary.org/obo/CARO> 
PREFIX foaf: <http://xmlns.com/foaf/0.1/>
PREFIX omcd: <http://www.openmath.org/cd/>
PREFIX prov: <http://www.w3.org/ns/prov#>
PREFIX qudt: <http://qudt.org/schema/qudt#>
PREFIX rdfs: <http://www.w3.org/2000/01/rdf-schema#>
PREFIX skos: <http://www.w3.org/2004/02/skos/core#>
PREFIX time: <http://www.w3.org/2006/time#>
PREFIX void: <http://rdfs.org/ns/void#>
PREFIX af-cq: <http://purl.allotrope.org/ontologies/common/qualifier#>
PREFIX af-fn: <http://purl.allotrope.org/ontologies/function#>
PREFIX af-re: <http://purl.allotrope.org/ontologies/realizable#>
PREFIX af-rl: <http://purl.allotrope.org/ontologies/role#>
PREFIX af-sp: <http://purl.allotrope.org/ontologies/spatial#> 
PREFIX afs-c: <http://purl.allotrope.org/shapes/common#>
PREFIX afs-q: <http://purl.allotrope.org/shapes/qudt#>
PREFIX shacl: <http://www.w3.org/ns/shacl#>
PREFIX vcard: <http://www.w3.org/2006/vcard/ns#>
PREFIX adf-dc: <http://purl.allotrope.org/ontologies/datacube#>
PREFIX adf-dp: <http://purl.allotrope.org/ontologies/datapackage#>
PREFIX bfo: <http://purl.obolibrary.org/obo/BFO>
PREFIX af-cur: <http://purl.allotrope.org/ontologies/curation#>
PREFIX af-gaz: <http://purl.obolibrary.org/obo/GAZ>
PREFIX iao: <http://purl.obolibrary.org/obo/IAO>
PREFIX af-map: <http://purl.allotrope.org/ontologies/mapping#>
PREFIX mop: <http://purl.obolibrary.org/obo/MOP>
PREFIX obi: <http://purl.obolibrary.org/obo/OBI>
PREFIX afs-dc: <http://purl.allotrope.org/shapes/datacube#>
PREFIX afs-hr: <http://purl.allotrope.org/shapes/resources#>
PREFIX dctype: <http://purl.org/dc/dcmitype/>
PREFIX premis: <http://www.loc.gov/premis/rdf/v1#>
PREFIX chmo: <http://purl.obolibrary.org/obo/CHMO>
PREFIX envo: <http://purl.obolibrary.org/obo/ENVO>
PREFIX af-math: <http://purl.allotrope.org/ontologies/math#>
PREFIX ncbi: <http://purl.obolibrary.org/obo/NCBITaxon>
PREFIX pato: <http://purl.obolibrary.org/obo/PATO>
PREFIX chebi: <http://purl.obolibrary.org/obo/CHEBI>
PREFIX qudt-ext: <http://purl.allotrope.org/ontology/qudt-ext/schema#>
PREFIX unit-ext: <http://purl.allotrope.org/ontology/qudt-ext/unit#>
PREFIX uberon: <http://purl.obolibrary.org/obo/UBERON>
PREFIX qudt-unit: <http://qudt.org/vocab/unit#>
PREFIX adf-dc-hdf: <http://purl.allotrope.org/ontologies/datacube-hdf-map#>
PREFIX quantity-ext: <http://purl.allotrope.org/ontology/qudt-ext/quantity#>

CONSTRUCT {
                ?subj ?pred ?obj .
                <http://purl.allotrope.org/voc/afo/merged/CR/2019/09> a owl:Ontology ;
                                prov:wasDerivedFrom ?versionIri ;
                                dct:rights <http://purl.allotrope.org/voc/attribution> ;
                                dct:rights <http://purl.allotrope.org/voc/copyright> ;
                                dct:contributor <http://www.allotrope.org> ;
                                dct:title "Allotrope Foundation Ontology MERGED (CR/2019/09)" ;
                                dct:publisher <http://www.allotrope.org> ;
                                owl:versionIRI <http://purl.allotrope.org/voc/afo/merged/CR/2019/09> ;
                                owl:versionInfo "CR/2019/09" ;
                                dct:issued "2019-09-30T12:00:00Z"^^xsd:dateTime ;
                                dct:license <http://purl.allotrope.org/voc/creative-commons-attribution-license> .
                                                          ?subj rdfs:isDefinedBy ?source .
} WHERE {
                VALUES ?g {
                                <http://purl.allotrope.org/afo/voc/afo/CR/2019/09/afo/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/CR/2019/09/aft/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/CR/2019/09/relation/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/CR/2019/09/curation/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/perspective/CR/2019/09/molecular-scale/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/perspective/CR/2019/09/organization/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/perspective/CR/2019/09/portion-of-material/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/perspective/CR/2019/09/system/graph> 

                                <http://purl.allotrope.org/afo/voc/afo/REC/2019/09/afo/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/REC/2019/09/aft/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/REC/2019/09/relation/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/REC/2019/09/curation/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/perspective/REC/2019/09/molecular-scale/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/perspective/REC/2019/09/organization/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/perspective/REC/2019/09/portion-of-material/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/perspective/REC/2019/09/system/graph> 
                                <http://purl.allotrope.org/afo/voc/skos/REC/2018/10/skos/graph> 
                                <http://purl.allotrope.org/afo/voc/bfo/REC/2018/04/bfo-2-0/graph> 
                                <http://purl.allotrope.org/afo/voc/qb/REC/2018/10/cube/graph> 

                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/bga/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/calibration/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/cell-counting/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/chemical-reaction/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/chromatography/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/class-coordination/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/coating/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/detection/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/differential-scanning-calorimetry/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/electrochemistry/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/filtration/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/fingerprinting/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/gc/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/injection/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/lc/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/lc-ms/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/lc-uv/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/mass-spectrometry/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/osmometry/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/ph/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/plumbing/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/pumping/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/raman/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/sampling/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/titration/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/CR/2019/09/uv/graph> 

                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/bga/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/calibration/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/cell-counting/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/chemical-reaction/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/chromatography/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/detection/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/filtration/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/fingerprinting/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/gc/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/injection/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/lc/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/lc-ms/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/lc-uv/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/mass-spectrometry/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/plumbing/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/pumping/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/raman/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/sampling/graph> 
                                <http://purl.allotrope.org/afo/voc/afo/domain/REC/2019/09/uv/graph> 

                                <http://purl.allotrope.org/afo/voc/allotrope-public-license/graph> 
                                <http://purl.allotrope.org/afo/voc/apn-license/graph> 
                                <http://purl.allotrope.org/afo/voc/attribution/graph> 
                                <http://purl.allotrope.org/afo/voc/copyright/graph> 
                                <http://purl.allotrope.org/afo/voc/creative-commons-attribution-license/graph> 
                }
GRAPH ?g {
                ?subj ?pred ?obj .
                                                          {
                                                                        SELECT DISTINCT ?ontology ?versionIri WHERE  {
                                                                                      ?ontology a owl:Ontology .
                                                                                      ?ontology owl:versionIRI ?versionIri .
                                                                        } 
                                                          }
    FILTER (NOT EXISTS { ?subj a owl:Ontology } )
               OPTIONAL {
                                                                        GRAPH  ?x { 
                                                                                      ?subj skos:prefLabel ?label .
                                                                  ?ontology a owl:Ontology .
                                                                                      ?ontology owl:versionIRI ?source .
                                                          }
                                                          }
        }

}
EOF
)

curl -X POST --data-urlencode "query=$query" http://localhost:3030/Allotrope/query -o merged.ttl
